import { Fn } from '@regiondev/vue-utils';
import 'ant-design-vue/es/notification/style';
import { VNode } from 'vue';
export type NotificationType = 'success' | 'error' | 'info' | 'warning' | 'loading' | 'open';
export type NotificationOptions = {
    duration?: number;
    onClose?: Fn;
    placement?: 'topLeft' | 'topRight' | 'bottomLeft' | 'bottomRight';
    onClick?: Fn;
    description?: string;
    title?: VNode | string;
    type?: NotificationType;
    content?: VNode;
};
export declare function success(options?: NotificationOptions): void;
export declare function error(options?: NotificationOptions): void;
export declare function info(options?: NotificationOptions): void;
export declare function warning(options?: NotificationOptions): void;
export declare function warn(options?: NotificationOptions): void;
export declare function open(options?: NotificationOptions & {
    customIcon?: object | VNode;
}): void;
export declare function showNotification(options?: NotificationOptions & {
    customIcon?: object | VNode;
}): void;
