import o from "../../../@babel/runtime/helpers/esm/objectSpread2.rd.js";
import A from "../../../@babel/runtime/helpers/esm/defineProperty.rd.js";
import fe from "../../../@babel/runtime/helpers/esm/typeof.rd.js";
import H from "../../../@babel/runtime/helpers/esm/slicedToArray.rd.js";
import { createVNode as f, defineComponent as pe, computed as P, watchEffect as Ie, ref as de, toRef as $, watch as ve } from "vue";
import Te from "./panels/TimePanel/index.rd.js";
import Re from "./panels/DatetimePanel/index.rd.js";
import Oe from "./panels/DatePanel/index.rd.js";
import je from "./panels/WeekPanel/index.rd.js";
import Be from "./panels/MonthPanel/index.rd.js";
import Fe from "./panels/QuarterPanel/index.rd.js";
import Ee from "./panels/YearPanel/index.rd.js";
import Ae from "./panels/DecadePanel/index.rd.js";
import { isEqual as se } from "./utils/dateUtil.rd.js";
import { useInjectPanel as He, useProvidePanel as $e } from "./PanelContext.rd.js";
import { PickerModeMap as Ke } from "./utils/uiUtil.rd.js";
import { useInjectRange as Ge } from "./RangeContext.rd.js";
import We from "./utils/getExtraFooter.rd.js";
import qe from "./utils/getRanges.rd.js";
import { setDateTime as K, getLowerBoundTime as Le, setTime as Ue } from "./utils/timeUtil.rd.js";
import G from "../_util/hooks/useMergedState.rd.js";
import { warning as y } from "../vc-util/warning.rd.js";
import V from "../_util/KeyCode.rd.js";
import W from "../_util/classNames.rd.js";
function Qe() {
  return pe({
    name: "PickerPanel",
    inheritAttrs: !1,
    props: {
      prefixCls: String,
      locale: Object,
      generateConfig: Object,
      value: Object,
      defaultValue: Object,
      pickerValue: Object,
      defaultPickerValue: Object,
      disabledDate: Function,
      mode: String,
      picker: {
        type: String,
        default: "date"
      },
      tabindex: {
        type: [Number, String],
        default: 0
      },
      showNow: {
        type: Boolean,
        default: void 0
      },
      showTime: [Boolean, Object],
      showToday: Boolean,
      renderExtraFooter: Function,
      dateRender: Function,
      hideHeader: {
        type: Boolean,
        default: void 0
      },
      onSelect: Function,
      onChange: Function,
      onPanelChange: Function,
      onMousedown: Function,
      onPickerValueChange: Function,
      onOk: Function,
      components: Object,
      direction: String,
      hourStep: {
        type: Number,
        default: 1
      },
      minuteStep: {
        type: Number,
        default: 1
      },
      secondStep: {
        type: Number,
        default: 1
      }
    },
    setup: function(e, me) {
      var I = me.attrs, L = P(function() {
        return e.picker === "date" && !!e.showTime || e.picker === "time";
      }), U = P(function() {
        return 24 % e.hourStep === 0;
      }), Q = P(function() {
        return 60 % e.minuteStep === 0;
      }), Y = P(function() {
        return 60 % e.secondStep === 0;
      });
      process.env.NODE_ENV !== "production" && Ie(function() {
        var t = e.generateConfig, n = e.value, r = e.hourStep, c = r === void 0 ? 1 : r, l = e.minuteStep, i = l === void 0 ? 1 : l, v = e.secondStep, C = v === void 0 ? 1 : v;
        y(!n || t.isValidate(n), "Invalidate date pass to `value`."), y(!n || t.isValidate(n), "Invalidate date pass to `defaultValue`."), y(U.value, "`hourStep` ".concat(c, " is invalid. It should be a factor of 24.")), y(Q.value, "`minuteStep` ".concat(i, " is invalid. It should be a factor of 60.")), y(Y.value, "`secondStep` ".concat(C, " is invalid. It should be a factor of 60."));
      });
      var b = He(), z = b.operationRef, ge = b.panelRef, J = b.onSelect, T = b.hideRanges, x = b.defaultOpenValue, M = Ge(), X = M.inRange, R = M.panelPosition, D = M.rangedValue, _ = M.hoverRangedValue, m = de({}), Se = G(null, {
        value: $(e, "value"),
        defaultValue: e.defaultValue,
        postState: function(n) {
          return !n && x !== null && x !== void 0 && x.value && e.picker === "time" ? x.value : n;
        }
      }), Z = H(Se, 2), S = Z[0], he = Z[1], we = G(null, {
        value: $(e, "pickerValue"),
        defaultValue: e.defaultPickerValue || S.value,
        postState: function(n) {
          var r = e.generateConfig, c = e.showTime, l = e.defaultValue, i = r.getNow();
          return n ? !S.value && e.showTime ? fe(c) === "object" ? K(r, Array.isArray(n) ? n[0] : n, c.defaultValue || i) : l ? K(r, Array.isArray(n) ? n[0] : n, l) : K(r, Array.isArray(n) ? n[0] : n, i) : n : i;
        }
      }), ee = H(we, 2), O = ee[0], ne = ee[1], h = function(n) {
        ne(n), e.onPickerValueChange && e.onPickerValueChange(n);
      }, te = function(n) {
        var r = Ke[e.picker];
        return r ? r(n) : n;
      }, Ce = G(function() {
        return e.picker === "time" ? "time" : te("date");
      }, {
        value: $(e, "mode")
      }), ae = H(Ce, 2), w = ae[0], oe = ae[1];
      ve(function() {
        return e.picker;
      }, function() {
        oe(e.picker);
      });
      var re = de(w.value), ke = function(n) {
        re.value = n;
      }, Pe = function(n, r) {
        var c = e.onPanelChange, l = e.generateConfig, i = te(n || w.value);
        ke(w.value), oe(i), c && (w.value !== i || se(l, O.value, O.value)) && c(r, i);
      }, d = function(n, r) {
        var c = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : !1, l = e.picker, i = e.generateConfig, v = e.onSelect, C = e.onChange, N = e.disabledDate;
        (w.value === l || c) && (he(n), v && v(n), J && J(n, r), C && !se(i, n, S.value) && !(N != null && N(n)) && C(n));
      }, ie = function(n) {
        return m.value && m.value.onKeydown ? ([V.LEFT, V.RIGHT, V.UP, V.DOWN, V.PAGE_UP, V.PAGE_DOWN, V.ENTER].includes(n.which) && n.preventDefault(), m.value.onKeydown(n)) : (y(!1, "Panel not correct handle keyDown event. Please help to fire issue about this."), !1);
      }, be = function(n) {
        m.value && m.value.onBlur && m.value.onBlur(n);
      }, Ve = function() {
        var n = e.generateConfig, r = e.hourStep, c = e.minuteStep, l = e.secondStep, i = n.getNow(), v = Le(n.getHour(i), n.getMinute(i), n.getSecond(i), U.value ? r : 1, Q.value ? c : 1, Y.value ? l : 1), C = Ue(
          n,
          i,
          v[0],
          v[1],
          v[2]
        );
        d(C, "submit");
      }, ye = P(function() {
        var t, n = e.prefixCls, r = e.direction;
        return W("".concat(n, "-panel"), (t = {}, A(t, "".concat(n, "-panel-has-range"), D && D.value && D.value[0] && D.value[1]), A(t, "".concat(n, "-panel-has-range-hover"), _ && _.value && _.value[0] && _.value[1]), A(t, "".concat(n, "-panel-rtl"), r === "rtl"), t));
      });
      return $e(o(o({}, b), {}, {
        mode: w,
        hideHeader: P(function() {
          var t;
          return e.hideHeader !== void 0 ? e.hideHeader : (t = b.hideHeader) === null || t === void 0 ? void 0 : t.value;
        }),
        hidePrevBtn: P(function() {
          return X.value && R.value === "right";
        }),
        hideNextBtn: P(function() {
          return X.value && R.value === "left";
        })
      })), ve(function() {
        return e.value;
      }, function() {
        e.value && ne(e.value);
      }), function() {
        var t = e.prefixCls, n = t === void 0 ? "ant-picker" : t, r = e.locale, c = e.generateConfig, l = e.disabledDate, i = e.picker, v = i === void 0 ? "date" : i, C = e.tabindex, N = C === void 0 ? 0 : C, Ne = e.showNow, p = e.showTime, xe = e.showToday, Me = e.renderExtraFooter, De = e.onMousedown, le = e.onOk, _e = e.components;
        z && R.value !== "right" && (z.value = {
          onKeydown: ie,
          onClose: function() {
            m.value && m.value.onClose && m.value.onClose();
          }
        });
        var k, s = o(o(o({}, I), e), {}, {
          operationRef: m,
          prefixCls: n,
          viewDate: O.value,
          value: S.value,
          onViewDateChange: h,
          sourceMode: re.value,
          onPanelChange: Pe,
          disabledDate: l
        });
        switch (delete s.onChange, delete s.onSelect, w.value) {
          case "decade":
            k = f(Ae, o(o({}, s), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null);
            break;
          case "year":
            k = f(Ee, o(o({}, s), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null);
            break;
          case "month":
            k = f(Be, o(o({}, s), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null);
            break;
          case "quarter":
            k = f(Fe, o(o({}, s), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null);
            break;
          case "week":
            k = f(je, o(o({}, s), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null);
            break;
          case "time":
            delete s.showTime, k = f(Te, o(o(o({}, s), fe(p) === "object" ? p : null), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null);
            break;
          default:
            p ? k = f(Re, o(o({}, s), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null) : k = f(Oe, o(o({}, s), {}, {
              onSelect: function(a, u) {
                h(a), d(a, u);
              }
            }), null);
        }
        var j, B;
        T != null && T.value || (j = We(n, w.value, Me), B = qe({
          prefixCls: n,
          components: _e,
          needConfirmButton: L.value,
          okDisabled: !S.value || l && l(S.value),
          locale: r,
          showNow: Ne,
          onNow: L.value && Ve,
          onOk: function() {
            S.value && (d(S.value, "submit", !0), le && le(S.value));
          }
        }));
        var F;
        if (xe && w.value === "date" && v === "date" && !p) {
          var ue = c.getNow(), ce = "".concat(n, "-today-btn"), E = l && l(ue);
          F = f("a", {
            class: W(ce, E && "".concat(ce, "-disabled")),
            "aria-disabled": E,
            onClick: function() {
              E || d(ue, "mouse", !0);
            }
          }, [r.today]);
        }
        return f("div", {
          tabindex: N,
          class: W(ye.value, I.class),
          style: I.style,
          onKeydown: ie,
          onBlur: be,
          onMousedown: De,
          ref: ge
        }, [k, j || B || F ? f("div", {
          class: "".concat(n, "-footer")
        }, [j, B, F]) : null]);
      };
    }
  });
}
var Ye = Qe();
const Pn = function(q) {
  return f(Ye, q);
};
export {
  Pn as default
};
